import { Component, EventEmitter, Input, OnInit, Output } from '@angular/core';
import { OrientationService } from '../../../../services/orientation.service';
import { INeedItem, OrientationUtils } from '../../../../utils/orientationUtils';
import { NeedsType } from '../../enums/needs.enum';

@Component({
  selector: 'app-needs-selection',
  templateUrl: './needs-selection.component.html',
})
export class NeedsSelectionComponent implements OnInit {
  @Input() currentNeed: NeedsType;
  @Output() setNeedType = new EventEmitter<any>();
  @Output() validate = new EventEmitter<any>();
  public needsList: INeedItem[] = new OrientationUtils().needsList;

  constructor(public orientationService: OrientationService) {}

  ngOnInit() {
    if (this.orientationService.rdvUser || this.orientationService.rdvStructure) {
      this.needsList = this.needsList.filter(
        (item: INeedItem) => item.key == NeedsType.onlineDemarch || item.key == NeedsType.learnSkills
      );
    }
  }

  public selectNeed(event: NeedsType) {
    this.setNeedType.emit(event);
  }
  public getSelected(): string | NeedsType {
    const selected = this.needsList.filter((need) => need.key == this.currentNeed)[0];
    if (selected) {
      this.validate.emit();
      return selected.key;
    }
  }
}
