import { Injectable } from '@angular/core';
import { ToastrService } from 'ngx-toastr';

@Injectable({
  providedIn: 'root',
})
export class NotificationService {
  constructor(private toastr: ToastrService) {}

  public showSuccess(message: string, title: string = '', timeOut: number = 10000): void {
    this.toastr.success(message, title, {
      timeOut: timeOut,
    });
  }

  // Par défaut, l'erreur reste affichée jusqu'à ce qu'on clique dessus
  public showError(message: string, title: string = '', timeOut: number = 0): void {
    this.toastr.error(message, title, {
      timeOut: timeOut,
      disableTimeOut: timeOut ? false : true,
    });
  }
  public showErrorPleaseRetry(title: string, timeOut: number = 0): void {
    this.showError('Merci de réessayer plus tard ou de contacter un administrateur', title, timeOut);
  }

  // Par défaut, l'erreur reste affichée jusqu'à ce qu'on clique dessus
  public showAppNewVersion(): void {
    const update = this.toastr.info(
      'Une nouvelle version est disponible, cliquer ici pour mettre à jour.',
      'Nouvelle version',
      {
        disableTimeOut: true,
      }
    );

    update.onTap.subscribe((_action) => {
      window.location.reload();
    });
  }
}
